; Game Wizard Tester v1.0
; Created by Thomas J. Hruska
; (C) 1997 Shining Light Productions

#include "offti-82.h"
#include "multikey.h"

.ORG START_ADDR
.DB "GW Tester v1.0",0

LIVES         =TEXT_MEM    ; # of lives

  ROM_CALL(CLEARLCD)       ; Clears the display
  ld hl,$0000              ; $0000 -> hl
  ld (CURSOR_POS),hl       ; hl -> (CURSOR_POS)
  ld a,3                   ; 3 -> a
  ld (LIVES),a             ; 3 -> (LIVES)
  set 3,(IY+05)            ; Reverses the text
  ld hl,Title              ; Address of Title -> hl
  ld de,(PROGRAM_ADDR)     ; (PROGRAM_ADDR) -> de
  add hl,de                ; hl = hl + de
  ROM_CALL(D_ZT_STR)       ; Displays a zero terminated string
  res 3,(IY+05)            ; Normalizes the text
  ld hl,MainText           ; Address of MainText -> hl
  add hl,de                ; hl = hl + de
  ROM_CALL(D_ZT_STR)       ; Displays a zero terminated string
  ld hl,$0802              ; $0802 -> hl
  ld (CURSOR_POS),hl       ; hl -> (CURSOR_POS)
  ld hl,$0003              ; $0003 -> hl
  ROM_CALL(D_HL_DECI)      ; Display hl
Loop1:  
  Multi_Key(KEY_11)        ; Detect the [Y=] key
  jr z,Loop1               ; If not pressed, then jump to Loop1
  ld a,(LIVES)             ; (LIVES) -> a
  dec a                    ; a = a - 1
  ld (LIVES),a             ; a -> (LIVES)
  ld hl,$0802              ; $0802 -> hl
  ld (CURSOR_POS),hl       ; hl -> (CURSOR_POS)
  ld h,0                   ; 0 -> h
  ld l,a                   ; a -> l
  ROM_CALL(D_HL_DECI)      ; Display hl
Loop2:  
  Multi_Key(KEY_12)        ; Detect the [WINDOW] key
  jr z,Loop2               ; If not pressed, then jump to Loop2
  ld a,(LIVES)             ; (LIVES) -> a
  ld hl,$0003              ; $0003 -> hl
  ld (CURSOR_POS),hl       ; hl -> (CURSOR_POS)
  cp 3                     ; If a=3, then return zero
  jr z,YouGotIt            ; If zero, then jump to YouGotIt
  
  ld hl,YouLose            ; Address of YouLose -> hl
  ld de,(PROGRAM_ADDR)     ; (PROGRAM_ADDR) -> de
  add hl,de                ; hl = hl + de
  ROM_CALL(D_ZT_STR)       ; Displays a zero terminated string
  CALL_(Delay)             ; Delays for 1 second
  ret                      ; Return to caller

YouGotIt:
  ld hl,YouWin             ; Address of YouWin -> hl
  ld de,(PROGRAM_ADDR)     ; (PROGRAM_ADDR) -> de
  add hl,de                ; hl = hl + de
  ROM_CALL(D_ZT_STR)       ; Displays a zero terminated string
  CALL_(Delay)             ; Delays for 1 second
  ret                      ; Return to caller

Delay:
  ld bc,200
Delay2:
  halt
  dec bc
  ld a,b
  or c
  jr nz,Delay2
  ret

#include "multikey.inc"

Title:
.DB "Game Wizard Test"
.DB "By Thomas Hruska",0

MainText:
.DB "Lives:          "
.DB "                "
.DB "Objective:      "
.DB "Freeze the lives"
.DB "at 3.           ",0

YouLose:
.DB "You Lost.",0

YouWin:
.DB "You Win!",0

.END
